﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using Microsoft.Crm.Sdk;
using Microsoft.Crm.SdkTypeProxy;
using Microsoft.Crm.Sdk.Query;
using System.Text;

namespace CRM40SilverlightDemo.Web
{
    /// <summary>
    /// Summary description for CrmServiceWrapper
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]
    // To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
    // [System.Web.Script.Services.ScriptService]
    public class CrmServiceWrapper : System.Web.Services.WebService
    {

        [WebMethod]
        public string GetCRMData()
        {
            // this will return all users in CRM in a single XML structure.
            StringBuilder xml = new StringBuilder();
            CrmService service = GetCRMService();

            QueryExpression query = new QueryExpression();
            query.EntityName = "systemuser";
            query.ColumnSet = new AllColumns();

            RetrieveMultipleRequest retrieve = new RetrieveMultipleRequest();
            retrieve.Query = query;
            retrieve.ReturnDynamicEntities = false;

            RetrieveMultipleResponse retrieved = (RetrieveMultipleResponse)service.Execute(retrieve);

            xml.Append("<Users>");

            for (int i = 0; i < retrieved.BusinessEntityCollection.BusinessEntities.Count; i++)
            {
                systemuser user = (systemuser)retrieved.BusinessEntityCollection.BusinessEntities[i];

                // create a string represenation to return to Silverlight app
                xml.Append("<User");
                xml.Append(" FirstName ='" + user.firstname + "'");
                xml.Append(" LastName = '" + user.lastname + "'");
                xml.Append(" SystemUserId = '" + user.systemuserid.ToString() + "'");
                xml.Append(" JobTitle = '" + user.jobtitle + "'");
                xml.Append("/>");
            }

            xml.Append("</Users>");

            return xml.ToString();
        }

        [WebMethod]
        public string PostCRMData(string userId, string nickname)
        {
            CrmService service = GetCRMService();

            Key kid = new Key();
            kid.Value = new Guid(userId);
            systemuser entity = new systemuser();
            entity.systemuserid = kid;

            entity.nickname = nickname;

            service.Update(entity);

            return "success";
        }

        static private CrmService GetCRMService()
        {
            CrmService service = new CrmService();
            CrmAuthenticationToken token = new Microsoft.Crm.Sdk.CrmAuthenticationToken();
            token.OrganizationName = "Contoso";
            service.Url = "http://localhost:5555/MSCRMServices/2007/crmservice.asmx";
            service.Credentials = System.Net.CredentialCache.DefaultCredentials;
            service.CrmAuthenticationTokenValue = token;
            return service;

        }
    }
}
