﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Xml.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using CRM40SilverlightDemo.CrmServiceWrapper;

namespace CRM40SilverlightDemo
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            // Call the GetCRMData web method
            CrmServiceWrapperSoapClient proxyGet = new CrmServiceWrapperSoapClient();
            proxyGet.GetCRMDataCompleted += new EventHandler<GetCRMDataCompletedEventArgs>(proxy_GetCRMDataCompleted);
            proxyGet.GetCRMDataAsync();

            // Call the PostCRMData web method
            CrmServiceWrapperSoapClient proxyPost = new CrmServiceWrapperSoapClient();
            proxyPost.PostCRMDataCompleted += new EventHandler<PostCRMDataCompletedEventArgs>(proxy_PostCRMDataCompleted);
            proxyPost.PostCRMDataAsync("f04b02d9-ad5f-e011-a513-000c29330bd5","My Nickname");
        }

        // Called asynchronously when the GetCRMData web method returns data 
        void proxy_GetCRMDataCompleted(object sender, GetCRMDataCompletedEventArgs e)
        {
            XDocument xDoc = XDocument.Parse(e.Result);

            string firstName;
            string lastName;
            string ID;
            string title;

            // loop through the results
            foreach (XElement element in xDoc.Descendants("User"))
            {
                firstName = GetAttributeValue(element, "FirstName");
                lastName = GetAttributeValue(element, "LastName");
                ID = GetAttributeValue(element, "SystemUserId");
                title = GetAttributeValue(element, "JobTitle");
            }

        }

        private string GetAttributeValue(XElement element, string strAttributeName)
        {
            if (element.Attribute(strAttributeName) != null)
            {
                return element.Attribute(strAttributeName).Value;
            }
            return string.Empty;
        }

        // Called asynchronously when the PostCRMData web method returns data 
        void proxy_PostCRMDataCompleted(object sender, PostCRMDataCompletedEventArgs e)
        {
            // do something with the data returned
            string result = e.Result.ToString();
        }
    }
}
